;--------------------------------------
;  Control Sum Cript Algorithm  v1.0  - CSCA1
;--------------------------------------
;  Date: 3.09.2007
;
;  created by rpy3uH (aka ahilles)
;    E-Mail: ahilles1806@rambler.ru
;            gruzino-abhaz@rambler.ru
;

format PE GUI 4.0 DLL
entry DllEntryPoint

include '..\..\include\win32a.inc'

section '.code' code readable executable

proc DllEntryPoint hinstDLL,fdwReason,lpvReserved
	mov	eax,TRUE
	ret
endp

GET_CRC32:

; IN
;       ESI = block offset
;       EDI = block size
; OUT
;       EAX = CRC32

	push esi
	push edi
	push ecx
	push ebx
	push edx

	cld
	xor	ecx,ecx
	dec	ecx
	mov	edx,ecx
   .NextByteCRC:
	xor	eax,eax
	xor	ebx,ebx
	lodsb
	xor	al,cl
	mov	cl,ch
	mov	ch,dl
	mov	dl,dh
	mov	dh,8
   .NextBitCRC:
	shr	bx,1
	rcr	ax,1
	jnc	.NoCRC
	xor	ax,08320h
	xor	bx,0EDB8h
   .NoCRC:
	dec	dh
	jnz	.NextBitCRC
	xor	ecx,eax
	xor	edx,ebx
	dec	edi
	jnz	.NextByteCRC
	not	edx
	not	ecx
	mov	eax,edx
	rol	eax,16
	mov	ax,cx

	pop edx
	pop ebx
	pop ecx
	pop edi
	pop esi
	ret


GetZSLength:
; get zero-string length
;IN
;       EDI ZS offset
;OUT
;       EAX ZS length

	push ecx
	push esi

	cld
	xor   al, al
	mov ecx, 0FFFFFFFFh
	mov esi, edi
	repne scasb
	sub edi, esi
	mov eax, edi
	dec eax

	pop esi
	pop ecx
	ret


NextPasswordMod:
;IN
;   ESI offset ZS of password
;   EAX ordinal number
;   EDI password length
	pushad
	dec edi

	xor edx, edx
	div edi
	add esi, edx
	mov bh, [esi]
	mov ecx, edi
	sub ecx, edx
   .next:
	mov bl, [esi+1]
	mov [esi], bl
	inc esi
	loop .next
	mov [esi], bh

	popad
	ret

proc CSCA1 DataAddress, DataSize, Password
; DataAddress - data offset
; DataSize -    data size
; Password -    offset ZS of password
   local PasswordCp:DWORD
   local PasswordLength:DWORD

	pushad
	mov  edi, [Password]
	call GetZSLength
	mov  [PasswordLength], eax

	stdcall [VirtualAlloc],0,eax, MEM_COMMIT+MEM_RESERVE, PAGE_READWRITE
	mov edi, eax	  ; eax = password offset
	mov esi, [Password]
	mov ecx, [PasswordLength]
	rep movsb
	mov [PasswordCp], eax

	xor ecx, ecx
    .next:     ; ecx
	mov esi, [PasswordCp]
	mov edi, [PasswordLength]
	mov eax, ecx
	call NextPasswordMod

	mov esi, [PasswordCp]
	mov edi, [PasswordLength]
	call GET_CRC32	 ;eax = CRC32 of current password mod
	mov edi, [DataAddress]
	imul edx, ecx,4  ;edx = current position
	add edi, edx	 ; edi = current offset

	mov ebx, [DataSize]

	sub ebx, edx
	cmp ebx, 0
	jz .end
	cmp ebx, 4
	jl .not_full_xor

     .full_xor:
	xor [edi], eax
	inc ecx
	jmp .next
     .not_full_xor:
	mov ecx, ebx
       .rep:
	dec ecx
	add edi, ecx
	mov dl, [edi]
	xor dl, al
	mov [edi], dl
	sub edi, ecx
	inc ecx
	shr eax, 8
	loop .rep
    .end:
	stdcall [VirtualFree],[PasswordCp],0, MEM_RELEASE

	popad
	ret
endp

section '.idata' import data readable writeable

  library kernel,'KERNEL32.DLL'

  import kernel,\
	 VirtualAlloc, 'VirtualAlloc',\
	 VirtualFree, 'VirtualFree'

section '.edata' export data readable

  export 'CSCA1.DLL',\
	 CSCA1, 'CSCA1'

section '.reloc' fixups data discardable
